



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>OC-方法的声明和实现、匿名对象</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">OC-方法的声明和实现、匿名对象</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-15 19:12:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>方法声明：</p>
<p>　　<img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/817558/201511/817558-20151107113454086-1468166663.png" /></p>
<p>方法调用：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/817558/201511/817558-20151107113500383-24038594.png" /></p>
<p>*冒号也是方法名的一部分</p>
<p>*同一个类中不允许两个对象方法同名</p>
<p>练习</p>
<p>给Car类设计一个方法，用来和其他车比较车速，如果快返回1，慢返回-1，相同返回0</p>
<div>
<pre class="prettyprint linenums">#import &lt;Foundation/Foundation.h&gt;<br />
@interface Car : NSObject<br />
{<br />
    @public<br />
    int speed;<br />
}

- (int)compareSpeedWithOther:(Car *)other;

@end

@implementation Car<br />
- (int)compareSpeedWithOther:(Car *)other;<br />
{<br />
    //speed //调用方法的speed<br />
    //other-&gt;speed//访问传入的speed<br />
    return speed - other-&gt;speed;<br />
}<br />
@end

int main()<br />
{<br />
    Car *c1 = [Car new];<br />
    c1-&gt;speed = ;

    Car *c2 = [Car new];<br />
    c2-&gt;speed = ;

    int a = [c1 compareSpeedWithOther:c2];

    CSLog(@"a=%d", a); //输出20<br />
}</pre>
</div>
<p>匿名：（不推荐写）</p>
<div>
<pre class="prettyprint linenums">int main()<br />
{<br />
    Car *c; //定义指针<br />
    c = [Car new]; //创建对象，赋值给指针<br />
    //可以合成为一句：Car *c = [Car new];<br />
    [c run];

    return ;<br />
}<br />
//匿名<br />
int main()<br />
{<br />
    [Car new]-&gt;speed = ;<br />
    [[Car new] run]; //speed 为0 ，与上边无关系

    return ;<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8mw6zoq.html">python socket</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8or1d18.html">c&num;面向对象基础  类、方法、方法重载</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q21yyv8.html">Python学习【第二篇】Python入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7y2z1q.html">android 高效加载大图</a>
		</li>
						<li><a href="https://www.batexi.com/a/39ro0549.html">把sql server 2000的用户表的所有者改成dbo</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wv05xq.html">&period;NET程序内，访问私有或者保护成员的技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y0wleq.html">C&num; List&amp;lt&semi;T&amp;gt&semi;转为 DataTable</a>
		</li>
						<li><a href="https://www.batexi.com/a/950x2j68.html">MySQLdb 连接Mysql 数据库出错解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j34xl8.html">【有意思的BUG】默认置灰的属性的值传递</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey3z2x9.html">洗礼灵魂，修炼python（5）--python操作符，内置函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jlwex8.html">Miner&period;java 爬虫启动类</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2mlzoq.html">js把某个div或其他元素用图片的形式导出或下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdww06v9.html">利用AnyProxy代理监控APP流量</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25505oq.html">使用Kubeadm搭建Kubernetes&lpar;1&period;12&period;2&rpar;集群</a>
		</li>
						<li><a href="https://www.batexi.com/a/90ryyom9.html">vsCode如何从github拉取项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdyzx09.html">java框架之SpringBoot&lpar;3&rpar;-日志</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwljg3l9.html">Linux上传和下载之Xshell</a>
		</li>
						<li><a href="https://www.batexi.com/a/9635zx39.html">Android shell command execute Demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjp1708.html">静态编译opencv3&period;4&period;0</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvery5j9.html">SQL Server优化50法&lpar;转载&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/m96g7en8.html">java-二维码编写zxing</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gkdp08.html">安装centos虚拟机</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k45mr9.html">Google Android 6&period;0 权限完全解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4wn739.html">Selenium&plus;WebDriver&plus;Python 定时控制任务</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rm0348.html">用MathType编辑横三角形的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq12jo29.html">dede使用方法---如何添加视频</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4wdl09.html">&lbrack;bzoj1009&rsqb;&lbrack;HNOI2008&rsqb;GT考试</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql7w119.html">ubuntu16&period;04安装重启后显示黑屏</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4w7nn9.html">【BZOJ-4692】Beautiful Spacing          二分答案 &plus; 乱搞（DP？）</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxx4dvq.html">UVA11426        欧拉函数</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
